= How do I add PMD analysis to my project? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

[http://pmd.sourceforge.net/ PMD] runs against Java source files. It can find dead code (e.g., assignments to variables 
that are never subsequently read), performance issues (e.g., misuse of + in !StringBuffer assignments, instantiating new 
objects in loops), style issues (e.g., final static variables should be all caps, unused import statements), and 
potentially dangerous code practices (e.g., assignments from instance to static field). 

== For Maven projects ==

To use PMD in a Maven project, add the following lines to your `pom.xml` file with the appropriate value 
for `targetJdk`:

{{{
#!text/xml
<project>
  ...
  <reporting>
    <plugins>
      <plugin>
        <groupId>org.apache.maven.plugins</groupId>
        <artifactId>maven-pmd-plugin</artifactId>
        <configuration>
          <targetJdk><%= node['java']['jdk_full_version'] %></targetJdk>
          <rulesets>
            <ruleset>pmd-ruleset.xml</ruleset>
          </rulesets>
        </configuration>
      </plugin>
    </plugins>
  </reporting>
  ...
</project>
}}}

You can invoke the PMD analysis with `mvn pmd:pmd`, or PMD will report its findings as part of the Maven site report 
(`mvn site`).

== For Ant builds ==

To use PMD in an Ant project, add the following files to a directory in your source tree (`tools/pmd-<%= node['tools']['pmd-bin']['version'] %>`):
 * `lib/`
   * `asm-3.1.jar`
   * `jaxen-1.1.1.jar`
   * `pmd-<%= node['tools']['pmd-bin']['version'] %>.jar`
 * `gg-pmd-report.xslt` 
 * `pmd-gg.css`
 * `pmd-ruleset.xml`

If you prefer to keep the PMD libraries outside your source tree, change the locations for the `tools.dir` and/or
the `pmd.lib.dir` properties in the lines below. You can use a centralized `pmd-ruleset.xml` file (e.g., if
you want all projects to use the same rules), or check in a project-specific configuration file to your source tree.

Add the following lines to your `build.xml` file. `build.dir`, `compile.classpath`, `junit.lib.dir`, `src.dir`, 
and `test.src.dir` should be set appropriately. 

{{{
#!text/xml
	<property name="tools.dir" location="tools"/>
	<property name="pmd.dir" location="${tools.dir}/pmd-<%= node['tools']['pmd-bin']['version'] %>"/>
	<property name="pmd.lib.dir" location="${pmd.dir}/lib"/>
	<property name="pmd.ruleset.file" location="${pmd.dir}/pmd-ruleset.xml"/>
	<property name="pmd.xsl.file" location="${pmd.dir}/gg-pmd-report.xslt"/>
	<property name="pmd.css.file" location="${pmd.dir}/pmd-gg.css"/>

	<property name="pmd.build.dir" location="${build.dir}/pmd"/>

	<property name="report.dir" location="${build.dir}/reports"/>
	<property name="pmd.report.dir" location="${report.dir}/pmd"/>

	<path id="test.classpath">
		<path refid="compile.classpath"/>
		<fileset dir="${junit.lib.dir}" includes="**/*.jar"/>
	</path>
	<path id="pmd.classpath">
		<path refid="test.classpath"/>
		<pathelement path="${pmd.build.dir}"/>
		<fileset dir="${pmd.lib.dir}" includes="**/*.jar"/>
	</path>

	<taskdef name="pmd" classname="net.sourceforge.pmd.ant.PMDTask" classpathref="pmd.classpath"/>

	<target name="pmd" description="Analyze the source code with PMD">
		<property name="pmd.report.xml" location="${pmd.report.dir}/pmd.xml"/>
		<mkdir dir="${pmd.report.dir}"/>
		<pmd shortFilenames="true" targetjdk="<%= node['java']['jdk_full_version'] %>" rulesetfiles="${pmd.ruleset.file}">
			<formatter type="xml" toFile="${pmd.report.xml}"/>
			<fileset dir="${src.dir}" includes="**/*.java"/>
			<fileset dir="${test.src.dir}" includes="**/*.java"/>
		</pmd>
		
		<property name="pmd.report.html" location="${pmd.report.dir}/index.html"/>
		<xslt in="${pmd.report.xml}" style="${pmd.xsl.file}" out="${pmd.report.html}"/>
		<copy file="${pmd.css.file}" todir="${pmd.report.dir}"/>
		<echo message="PMD report is at ${pmd.report.html}"/>
	</target>
}}}

== Customizing rules ==

To customize which rules are run, edit the `pmd-ruleset.xml` file. Rules can be enabled and disabled, and some rules can be 
configured to apply in some situations but not others. 

=== More information ===

 * [http://maven.apache.org/plugins/maven-pmd-plugin/ Maven options]
 * [http://pmd.sourceforge.net/ant-task.html Ant options]

<%= node['trac']['wiki']['footer'] %>